Summary:     High-performance mail store with imap and pop3
Name:        cyrus-imapd
Version:     2.2.12
Release:     10.pp
License:     BSD
Group:       System Environment/Daemons
Source0:     ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/%{name}-%{version}.tar.gz
Source1:     cyrus.conf
Source2:     %{name}.init
Source3:     %{name}.sysconfig
Source4:     imapd.conf
Source5:     imap.pamd
Source6:     pop.pamd
Source7:     http://belnet.dl.sourceforge.net/sourceforge/cyrus-utils/quotacheck.tar.gz
Patch0:      %{name}-bare_newlines.patch
Patch1:      %{name}-quota_speedup.patch
Patch2:      %{name}-hashdirdepth.patch
Patch3:      http://email.uoa.gr/download/cyrus/%{name}-%{version}/%{name}-%{version}-autocreate-0.9.2.diff
Patch4:      %{name}-autocreate_hashdirdepth.patch
Patch5:      http://email.uoa.gr/download/cyrus/%{name}-%{version}/%{name}-%{version}-autosievefolder-0.6.diff
Patch6:      http://email.uoa.gr/download/cyrus/%{name}-2.2.10/%{name}-2.2.10-rmquota+deletemailbox-0.1.diff
URL:         http://andrew2.andrew.cmu.edu/cyrus/imapd/
Buildroot:   /var/tmp/%{name}-root
Packager:    Peter Pramberger <peter.pramberger@member.fsf.org>
Provides:    %{name}.pp imapd popd pop3d imapdaemon popdaemon pop3daemon
Conflicts:   imap courier-imap
Requires:    krb5-libs openssl097 db4 cyrus-sasl2 zlib pam perl
Requires:    perl(Digest::MD5)
Prereq:      /bin/bash /usr/sbin/useradd /sbin/chkconfig
BuildPrereq: gcc /bin/mkdir /usr/bin/make /usr/bin/install
BuildPrereq: krb5-devel openssl097-devel db4-devel cyrus-sasl2-devel
BuildPrereq: zlib-devel pam-devel perl bison flex tcp_wrappers
ExclusiveOS: linux

%description
The Cyrus IMAP server is a scalable enterprise mail system designed
for use from small to large enterprise environments using standards-
based technologies.

A full Cyrus IMAP implementation allows a seamless mail and bulletin
board environment to be set up across multiple servers. It differs
from other IMAP server implementations in that it is run on "sealed"
servers, where users are not normally permitted to log in. The mailbox
database is stored in parts of the filesystem that are private to the
Cyrus IMAP system. All user access to mail is through software using
the IMAP, POP3, or KPOP protocols.


%package devel
Summary:     Development tools for the cyrus-imapd server.
Group:       Development/Libraries
Requires:    %{name} = %{version}-%{release} %{name}.pp
Provides:    %{name}-devel.pp

%description devel
The %{name}-devel package contains the static libraries and header
files for developing software for cyrus-imapd.


%prep
%setup -q -a 7
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
cp -r master/conf .
cp quotacheck/README README.quotacheck
chmod a-x README*
chmod a+x tools/*
# Correct wrong paths
for file in `find . -type f -exec fgrep -l /bin/perl {} \;`; do
   cp -f $file tmpfile
   sed -e 's+#!/user/local/bin/perl+#!/usr/bin/perl+g' \
       -e 's+#!/usr/local/bin/perl+#!/usr/bin/perl+g' \
       -e 's+#!/usr/local/bin/perl5+#!/usr/bin/perl+g' \
       -e 's+#!/usr/bin/perl5+#!/usr/bin/perl+g' \
       -e 's+#!/bin/perl+#!/usr/bin/perl+g' tmpfile > $file
   rm -f tmpfile
done
# We do not want them in the doc dir!
find . -name CVS -depth -exec rm -rf {} \;
find . -name .cvsignore -depth -exec rm -rf {} \;


%build
export CPPFLAGS="-I/usr/kerberos/include"
export CFLAGS="$RPM_OPT_FLAGS $CPPFLAGS"
export LDFLAGS="-L/usr/kerberos/lib"
export PERL="/usr/bin/perl"
if [ ! -x /usr/bin/makedepend ]; then
   cd makedepend
   ./configure --prefix=/usr
   make all
   install -m 755 makedepend /usr/bin
   cd ..
fi
./configure \
	--prefix=/usr                            \
	--sysconfdir=/etc                        \
	--localstatedir=/var                     \
	--mandir=/usr/share/man                  \
	--enable-murder                          \
	--enable-listext                         \
	--enable-netscapehack                    \
	--with-cyrus-prefix=/usr/libexec/%{name} \
	--with-service-path=/usr/libexec/%{name} \
	--with-auth=unix                         \
	--with-openssl                           \
	--with-idle=idled                        \
	--with-com_err                           \
	--with-sasl                              \
	--with-perl                              \
	--with-libwrap                           \
	--without-snmp
make all


# Do not strip, only compress documentation
%define __os_install_post /usr/lib/rpm/brp-compress


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig
mkdir -p $RPM_BUILD_ROOT/usr/libexec/cyrus-imapd
mkdir -p $RPM_BUILD_ROOT/var/spool/imap/stage.
mkdir -p $RPM_BUILD_ROOT/var/lib/imap/{proc,db,socket,log,msg,sieve,user,quota}
make \
	DESTDIR=$RPM_BUILD_ROOT    \
	PREFIX=$RPM_BUILD_ROOT/usr \
	install

install -m 640 %{SOURCE1} %{SOURCE4} $RPM_BUILD_ROOT/etc
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/%{name}
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT/etc/pam.d/imap
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT/etc/pam.d/pop
mv -f $RPM_BUILD_ROOT/usr/libexec/cyrus-imapd/master \
	$RPM_BUILD_ROOT/usr/libexec/cyrus-imapd/cyrus-master
mv -f $RPM_BUILD_ROOT/usr/share/man/man8/master.8 \
	$RPM_BUILD_ROOT/usr/share/man/man8/cyrus-master.8

for file in pop3test nntptest lmtptest smtptest mupdatetest sivtest; do
   rm -f $RPM_BUILD_ROOT/usr/bin/$file
   ln -s imtest $RPM_BUILD_ROOT/usr/bin/$file
done

find $RPM_BUILD_ROOT/usr/lib/perl5 -name .packlist -exec rm -f {} \;
ln -s /var/lib/imap/sieve $RPM_BUILD_ROOT/usr/sieve

for file in `find . -type f -exec fgrep -l /bin/bash {} \;`; do
   cp -f $file tmpfile
   sed -e 's+/usr/local/bin/bash+/bin/bash+g' \
       -e 's+/usr/contributed/bin/bash+/bin/bash+g' tmpfile > $file
   rm -f tmpfile
done


%pre
if ! grep cyrus /etc/passwd > /dev/null 2>&1; then  
   /usr/sbin/useradd -u 76 -g mail -G mail -d /var/lib/imap \
        -r -s /bin/bash cyrus > /dev/null 2>&1
fi


%post
/sbin/chkconfig --add %{name}
/sbin/chkconfig %{name} on
cd /var/lib/imap
chattr +S . user quota user/* quota/* 2>/dev/null
chattr +S /var/spool/imap /var/spool/imap/* 2>/dev/null
# Add services
if ! grep imsp /etc/services >/dev/null 2>&1; then
   echo -e "imsp\t\t406/tcp" >> /etc/services
   echo -e "imsp\t\t406/udp" >> /etc/services
fi
if ! grep acap /etc/services >/dev/null 2>&1; then
   echo -e "acap\t\t674/tcp" >> /etc/services
   echo -e "acap\t\t674/udp" >> /etc/services
fi
if ! grep imaps /etc/services >/dev/null 2>&1; then
   echo -e "imaps\t\t993/tcp" >> /etc/services
   echo -e "imaps\t\t993/udp" >> /etc/services
fi
if ! grep pop3s /etc/services >/dev/null 2>&1; then
   echo -e "pop3s\t\t995/tcp" >> /etc/services
   echo -e "pop3s\t\t995/udp" >> /etc/services
fi
if ! grep kpop /etc/services >/dev/null 2>&1; then
   echo -e "kpop\t\t1109/tcp" >> /etc/services
   echo -e "kpop\t\t1109/udp" >> /etc/services
fi
if ! grep sieve /etc/services >/dev/null 2>&1; then
   echo -e "sieve\t\t2000/tcp" >> /etc/services
   echo -e "sieve\t\t2000/udp" >> /etc/services
fi
if ! grep lmtp /etc/services >/dev/null 2>&1; then
   echo -e "lmtp\t\t2003/tcp" >> /etc/services
   echo -e "lmtp\t\t2003/udp" >> /etc/services
fi
if ! grep fud /etc/services >/dev/null 2>&1; then
   echo -e "fud\t\t4201/tcp" >> /etc/services
   echo -e "fud\t\t4201/udp" >> /etc/services
fi
if [ -f /var/lock/subsys/%{name} ]; then
      /etc/rc.d/init.d/%{name} restart
fi


%preun
if [ $1 = 0 ] ; then
   /sbin/chkconfig %{name} off
   /sbin/chkconfig --del %{name}
   if [ -f /var/lock/subsys/%{name} ]; then
      /etc/rc.d/init.d/%{name} stop
   fi
fi


%clean
rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc COPYRIGHT README* quotacheck/*.pl
%doc %dir conf doc tools
%attr(640,cyrus,root) %config(noreplace) /etc/*.conf
%attr(644,root,root) %config(noreplace) /etc/pam.d/*
%attr(644,root,root) %config(noreplace) /etc/sysconfig/*
%attr(755,root,root) /etc/rc.d/init.d/*
%attr(755,root,root) /usr/bin/*
%attr(755,root,root) /usr/libexec/cyrus-imapd/*
%attr(750,cyrus,mail) %dir /var/spool/imap
%attr(750,cyrus,mail) %dir /var/lib/imap
%attr(750,cyrus,mail) /var/lib/imap/quota
%attr(750,cyrus,mail) /var/lib/imap/user
%attr(750,cyrus,mail) /var/lib/imap/sieve
%attr(750,cyrus,mail) /var/lib/imap/log
%attr(750,cyrus,mail) /var/lib/imap/msg
%attr(750,cyrus,mail) /var/lib/imap/proc
%attr(750,cyrus,mail) /var/lib/imap/db
%attr(750,cyrus,mail) /var/lib/imap/socket
/usr/lib/perl5/*
/usr/sieve
/usr/share/man/man1/*
/usr/share/man/man3/*
/usr/share/man/man5/*
/usr/share/man/man8/*

%files devel
%defattr(-,root,root)
/usr/include/*
/usr/lib/*.*a


%changelog
* Sat Feb 26 2005 peter.pramberger@member.fsf.org
- updated hashdirdepth patch

* Wed Feb 23 2005 peter.pramberger@member.fsf.org
- added quota patch
- added autocreate/autosieve patch
- added deletebox/rmquota patch

* Fri Feb 18 2005 peter.pramberger@member.fsf.org
- updated hashdirdepth patch

* Mon Feb 14 2005 peter.pramberger@member.fsf.org
- new version 2.2.12

* Sat Feb 12 2005 peter.pramberger@member.fsf.org
- added patch for MD5 hashing

* Fri Feb 04 2005 peter.pramberger@member.fsf.org
- upgraded to version 2.2.10

* Fri Jul 11 2003 peter.pramberger@member.fsf.org
- created

